<?php
/*
APPLICATION ATELIERPHP-WEBRAMA - VERSION 3.0	
Application permettant de visualiser des photos sur internet
SITE : WWW.ATELIERPHP.NET			
CONTACT : APPLICATIONS (arobase) ATELIERPHP (point) NET			

Copyright Jean-Marie & Thierry Poulhès Poulhès 2007-2008 Tous droits réservés.

Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
modifier suivant les termes de la “GNU General Public License” (GPL) telle que
publiée par la Free Software Foundation : soit la version 3 de cette
licence, soit (à votre gré) toute version ultérieure.

Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. 
Consultez la Licence Générale Publique GNU pour plus de détails:
<http://www.gnu.org/licenses/gpl-3.0.html> 
ou en français <http://www.april.org/groupes/trad-gpl/doc/GPLv3/www.rodage.org/gpl-3.0.fr.html> 
ou encore <http://fsffrance.org/gpl/gpl-fr.fr.html> 

Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
ce programme (fichier  : licence-gpl-3.0.html); si ce n’est pas le cas, consultez 
les liens ci-dessus.
*/
require ("../variables/variables.php");
require ("../fonctions/fonction_copy.php");
require ("../fonctions/recursive_remove_directory.php");
$colors =        array('noir',    'blanc',      'rouge',    'vert',    'bleu');
$colors_value_1 = array('0','255','255','0','0');
$colors_value_2 = array('0','255','0','192','0');
$colors_value_3 = array('0','255','0','0','255');
$copyright_size = array('fin', 'normal', 'gros');
$copyright_coef = array('50','35','20');
$position = array('haut_gauche','haut_centre','haut_droite','bas_gauche','bas_centre','bas_droite');
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<TITLE>Webrama, une application de atelierPHP : visionneuse photo multifonction</TITLE>
<LINK rel=stylesheet type="text/css" href="../styles/webrama_style.css">
</HEAD>
<BODY><center>
<h3>Webrama, ajout de photos dans le sous-dossier: <br /><?php echo $_REQUEST['dossier']."/".$_REQUEST['sous_dossier'];?><a href=../lisez_moi.html> Lisez-moi</a></h4>
</center>
Les fichiers à traiter doivent figurer dans le dossier /photos_depot/ <br />
NB: Cette routine ne fonctionne pas sur tous les hébergeurs, (erreur mémoire)
il est préférable de la faire tourner sur son PC si l'on a un serveur web installé<br />
Après traitement, par défaut trois sous-dossiers seront créés : 
<ul>
<li><b>photos/'dossier/sous_dossier'/diapos/</b> comprendra les photos à visualiser dans le diaporama (800x600)</li>
<li><b>photos/'dossier/sous_dossier'/vignettes/</b> comprendra les vignettes à visualiser dans le mode manuel (100x75)</li>
<li><b>photos/'dossier/sous_dossier'/legendes/</b> comprendra les légendes pour chaque photo (legendes.txt : légende générique)</li>
</ul>
<table align=left><tr>
<?php

set_time_limit (0);
ini_set("memory_limit","120M");
if (!isset($_REQUEST['validation']))
{
    echo "Photos actuellement dans le dossier <b>photo_dépot</b> :"; 
    $allDir = opendir("../photos_depot/");// ouvre le répertoire courrant
    $count = 0;
    unset($entryName);
    while($entryName = readdir($allDir))
    { 
    		if($entryName!="." && $entryName!=".." && $entryName!="Thumbs.db"){
          $entryName = fonction_retire_accents(utf8_encode($entryName));
    			$arrayDir[] = $entryName ;
    			$count++ ;
    		}
    }
    if ($count>0)
    {
      //affichage des photos dans photos_depot
      sort($arrayDir);
      $i=0;
      foreach($arrayDir as $myDir)
      { 
          $i++;
          if ( $i%6 == 0)
          {
            echo "</tr><tr>";
          }          
          $relDir = "../photos_depot/"; $myLink = '"'.$relDir.$myDir.'"' ;  $photo_name = '"'.$myDir.'"' ;
          echo "<td><a href=".$myLink."><small>$photo_name</small></a></td>";
      }
       ?>
      </tr></table><br clear="left">
      <FORM ACTION=<?php echo $_SERVER['PHP_SELF']?> METHOD=post enctype='multipart/form-data' >
      <input type='hidden' name='dossier' value=<?php echo $_REQUEST['dossier']?>>
      <input type='hidden' name='sous_dossier' value=<?php echo $_REQUEST['sous_dossier']?>>
      
      <table cellpadding=5 width=96%>
<!-- Taille vignettes-->
      <tr><td class=fichiers>Si ne voulez pas des vignettes, décochez, ou eventuellement modifiez leur taille</td>
          <td class=fichiers><input type='checkbox' name='vignettes_flag' checked>&nbsp;&nbsp;&nbsp;&nbsp;
          Largeur : <input type='text' name='vignettes_largeur' size='3' value= 100><small>mm </small>
          Hauteur : <input type='text' name='vignettes_hauteur' size='3' value= 75><small>mm (ratio 4/3 adapté à la plus petite des valeurs)</small>
          </td></tr>
<!-- Taille petites-->
      <tr><td class=fichiers>Si vous voulez des petites photos (pour le blog, en général), cochez, et eventuellement modifiez leur taille</td>
          <td class=fichiers><input type='checkbox' name='petites_flag'>&nbsp;&nbsp;&nbsp;&nbsp;
          Largeur : <input type='text' name='petites_largeur' size='3' value= 400><small>mm</small>
          Hauteur : <input type='text' name='petites_hauteur' size='3' value= 300><small>mm (ratio 4/3 adapté à la plus petite des valeurs)</small>
          </td></tr>
<!-- Taille grandes-->
      <tr><td class=fichiers>Si vous ne voulez pas des grandes photos (pour diaporama), décochez, ou eventuellement modifiez leur taille</td>
          <td class=fichiers><input type='checkbox' name='diapos_flag' checked>&nbsp;&nbsp;&nbsp;&nbsp;
          Largeur : <input type='text' name='diapos_largeur' size='3' value= 800><small>mm</small>
          Hauteur : <input type='text' name='diapos_hauteur' size='3' value= 600><small>mm (ratio 4/3 adapté à la plus petite des valeurs)</small>
          </td></tr>
<!-- Signature texte -->
      <tr><td class=fichiers>Si voulez une signature texte, cochez, indiquez la position correspondante et saisissez le texte pour la signature</td>
          <td class=fichiers><input type='checkbox' name='sign_txt'>&nbsp;&nbsp;&nbsp;&nbsp;
          <input type=text  name="signature_txt" size=50>
          <SELECT NAME=sign_color>";
          <?php
          for ($count=0;$count<= count($colors);$count++)
              {
                   echo "<OPTION value=$count>$colors[$count]</OPTION>";
              } ?>
          </select>
          <SELECT NAME=sign_text_position>";
          <?php
          for ($count=0;$count<= count($position);$count++)
              {
                   echo "<OPTION value=$count>$position[$count]</OPTION>";
              } ?>
          </select>
          </td>
       </tr>
<!-- Signature image -->
      <tr><td class=fichiers>Si voulez une signature image, cochez, indiquez la position correspondante <br />et indiquez la position de l'image à télécharger</td>
          <td class=fichiers><input type='checkbox' name='sign_image'>&nbsp;&nbsp;&nbsp;&nbsp;
          <input name='myFileName' type='file' size=52>
          <SELECT NAME=sign_image_position>";
          <?php
          for ($count=0;$count<= count($position);$count++)
              {
                   echo "<OPTION value=$count>$position[$count]</OPTION>";
              } ?>
          </select>
          </td>
      </tr>
<!-- copyright -->
      <tr><td class=fichiers>Si voulez un texte de copyright en travers de l'image, indiquez-le</td>
          <td class=fichiers><input type='checkbox' name='copyright_flag'>&nbsp;&nbsp;&nbsp;&nbsp;
          <input type=text  name="copyright" size=50 value="Photo non libre de droits ! ">
          <SELECT NAME=copyright_size>";
          <?php
          for ($count=0;$count<= count($copyright_size);$count++)
              {
                   echo "<OPTION value=$count>$copyright_size[$count]</OPTION>";
              } ?>
          </select>
          <SELECT NAME=copyright_color>";
          <?php
          for ($count=0;$count<= count($colors);$count++)
              {
                   echo "<OPTION value=$count>$colors[$count]</OPTION>";
              } ?>
          </select>
          </td>
      </tr>
<!-- photo pour dotclear -->
      <tr><td class=fichiers>Si vous utilisez dotclear, cochez et choisissez le fichier à afficher dans le blog :</td>
          <td class=fichiers colspan=1><input type='checkbox' name='dotclear'>&nbsp;&nbsp;<SELECT NAME=myFile>
         <?php
          sort($arrayDir);
          foreach($arrayDir as $myDir)
          { 
              echo "<OPTION VALUE=$myDir>".utf8_encode($myDir)."</OPTION>";
          }
          ?>
          </select></td></tr>
<!-- validation -->
      <tr><td colspan=2 align=right class=fichiers><INPUT TYPE='submit' name='validation' VALUE=' V A L I D E R  '></td></tr></table></form>
          <?php
    }
    else
    {
        echo "Il n'y a aucune photo à traiter dans le dossier 'photos_depot' !";
    }
}
else
{
  // Copie les images à ma bonne taille dans les dossiers
  $allDir = opendir("../photos_depot/");// ouvre le répertoire courrant
  unset($entryName);
  while($entryName = readdir($allDir))
  { 
  		if($entryName!="." && $entryName!=".."  && $entryName!="Thumbs.db" ){
      		$imagePath  = "../photos_depot/".$entryName ;
          $entryName = fonction_retire_accents(utf8_encode($entryName));
          $myFile = str_replace(".JPG",".jpg",$_POST['myFile']);
          $myFile = str_replace(".JPEG",".jpeg",$myFile);
          echo "<br />Traitement <i>".$entryName."</i> ";
          if (isset($_REQUEST['vignettes_flag']))
          {
          		saveThumbnail("../photos/".$_REQUEST['dossier']."/".$_REQUEST['sous_dossier']."/vignettes/".$entryName, $imagePath, $entryName, $_REQUEST['vignettes_largeur'], $_REQUEST['vignettes_hauteur']);  
              $size = getimagesize("../photos/".$_REQUEST['dossier']."/".$_REQUEST['sous_dossier']."/vignettes/".$entryName);  
              $myLink = '"'."../photos/".$_REQUEST['dossier']."/".$_REQUEST['sous_dossier']."vignettes/".$entryName.'"' ;  
              echo "<a href=".$myLink."> Vignette:<small>  ".$_REQUEST['vignettes_largeur']."x".$_REQUEST['vignettes_hauteur']." --> : ".$size[0]."x".$size[1]."</small></a> ";  
          }
          if (isset($_REQUEST['petites_flag']))
          {
          		saveThumbnail("../photos/".$_REQUEST['dossier']."/".$_REQUEST['sous_dossier']."/petites/".$entryName, $imagePath, $entryName, $_REQUEST['petites_largeur'], $_REQUEST['petites_hauteur']);      
              $size = getimagesize("../photos/".$_REQUEST['dossier']."/".$_REQUEST['sous_dossier']."/petites/".$entryName);  
              $myLink = '"'."../photos/".$_REQUEST['dossier']."/".$_REQUEST['sous_dossier']."petites/".$entryName.'"' ;  
              echo "<a href=".$myLink."> Petite:<small> ".$_REQUEST['petites_largeur']."x".$_REQUEST['petites_hauteur']." --> : ".$size[0]."x".$size[1]."</small></a> ";  
          }
          if (isset($_REQUEST['diapos_flag']))
          {
          		saveThumbnail("../photos/".$_REQUEST['dossier']."/".$_REQUEST['sous_dossier']."/diapos/".$entryName, $imagePath, $entryName, $_REQUEST['diapos_largeur'], $_REQUEST['diapos_hauteur']);      
              $size = getimagesize("../photos/".$_REQUEST['dossier']."/".$_REQUEST['sous_dossier']."/diapos/".$entryName);  
              $myLink = '"'."../photos/".$_REQUEST['dossier']."/".$_REQUEST['sous_dossier']."diapos/".$entryName.'"' ;  
              echo "<a href=".$myLink."> Diapo:<small> ".$_REQUEST['diapos_largeur']."x".$_REQUEST['diapos_hauteur']." --> : ".$size[0]."x".$size[1]."</small></a> ";  
          }
  		}
  }
  $myDir = $_REQUEST['sous_dossier'];
  if (isset($_REQUEST['dotclear']))
  {
    echo "<p>Pour ceux qui utilisent Dotclear ou un blogger similaire, ci-après le texte à 
    copier/coller dans la source, pour afficher la photo choisie précédemment dans la liste
    (le dossier webrama doit être au même niveaux que les dossiers de Dotclear). </p>";
    //fichier pour le blog visa
    echo '<i><font color=grey>&lt;table>
  &lt;body>
  &lt;tr>
  &lt;td>
  &lt;a title="Cliquer ici pour aller au diaporama, appuyer sur F11 pour passer en plein écran" 
  href="http://visa2000.net/blog/webrama/programmes/manuel.php?my_date='.$myDir.'&amp;my_photo='.$myFile.'">
  &lt;img class="visa" alt="image" src="http://visa2000.net/blog/webrama/photos/'.$myDir.'/petites/'.$myFile.'" 
  align=" right=" hspace="5" vspace="5" />&lt;/a>
  &lt;/td>&lt;/tr>&lt;/tbody>&lt;/table>&lt;p>&lt;/p>
  &lt;a href="http://visa2000.net/blog/webrama/programmes/webrama_1.php?flag_index=1&amp;my_date='.$myDir.'">
  Quelques photos de la journée&lt;/a>&lt;/p></font></i>';
  }
  echo "<br /><br /><a href=../programmes/voir_diapos.php?sous_dossier=$myDir&dossier=$_REQUEST[dossier]>Voir la page créée $_REQUEST[dossier]/$myDir</a>";
}
?>
<p></p>
<a href=../index.php><img src=../images/accueil.png alt=accueil /></a>
&nbsp;<a href="menu_admin.php">Retour menu administration</a>
<?php
//-------------------------------------------------------------------------
$dossier = "../";
include("../pied_de_page/pied_de_page.php");
?>

<?php
//----------------------- F O N C T I O N S ------------------
function saveThumbnail($saveToDir, $imagePath, $imageName, $max_x, $max_y) {
        global $colors_value_1 ,$colors_value_2 ,$colors_value_3; 
 		    $im   = imagecreatefromjpeg ($imagePath);
        $x = imagesx($im);
        $y = imagesy($im);
        
        if (($max_x/$max_y) < ($x/$y)) {
            $save = imagecreatetruecolor($x/($x/$max_x), $y/($x/$max_x));
        }
        else {
            $save = imagecreatetruecolor($x/($y/$max_y), $y/($y/$max_y));
        }
        ImageCopyResampled($save, $im, 0, 0, 0, 0, imagesx($save), imagesy($save), $x, $y);  
//signature texte
       if (isset($_REQUEST['sign_txt']))
       {
        switch ($_REQUEST['sign_text_position'])
          {
            //Haut gauche
            case 0:
            $x_pos = 3;
            $y_pos = 0;
            break;
            //Haut centre
            case 1:
            $x_pos = imagesx($save)/2 - 5*strlen($_REQUEST['signature_txt']);
            $y_pos = 0;
            break;
            //Haut droite
            case 2:
            $x_pos = imagesx($save) - 10*strlen($_REQUEST['signature_txt']);
            $y_pos = 0;
            break;
            //bas gauche
            case 3:
            $x_pos = 3;
            $y_pos = $max_y - 20;
            break;
            //bas_centre
            case 4:
            $x_pos = imagesx($save)/2 - 5*strlen($_REQUEST['signature_txt']);
            $y_pos = imagesy($save) - 20;
            break;
            //bas droit
            case 5:
            $x_pos = imagesx($save) - 10*strlen($_REQUEST['signature_txt']);;
            $y_pos = imagesy($save) - 20;
            break;            
          }
        $textcolor = imagecolorallocate($save, $colors_value_1[$_REQUEST['sign_color']],$colors_value_2[$_REQUEST['sign_color']],$colors_value_3[$_REQUEST['sign_color']]);
        imagestring($save, 5, $x_pos, $y_pos ,$_REQUEST['signature_txt'],$textcolor);
        }
//signature image
       if (isset($_REQUEST['sign_image']) and  imagesx($save) > 200 )
       {
            $filename = $_FILES['myFileName']['tmp_name'];
     		    $im_sign = imagecreatefromjpeg($filename);
            // Calcul des nouvelles dimensions
            list($width_src, $height_src) = getimagesize($filename);
            switch ($_REQUEST['sign_image_position'])
              {
                //Haut gauche
                case 0:
                $x_pos = 0;
                $y_pos = 0;
                break;
                //Haut centre
                case 1:
                $x_pos = imagesx($save)/2 - $width_src/2;
                $y_pos = 0;
                break;
                //Haut droite
                case 2:
                $x_pos = imagesx($save) - $width_src ;
                $y_pos = 0;
                break;
                //bas gauche
                case 3:
                $x_pos = 0;
                $y_pos = imagesy($save) - $height_src ;
                break;
                //bas_centre
                case 4:
                $x_pos = imagesx($save)/2 - $width_src/2;
                $y_pos = imagesy($save) - $height_src;
                break;
                //bas droit
                case 5:
                $x_pos = imagesx($save) - $width_src;
                $y_pos = imagesy($save) - $height_src;
                break;            
              }
            imagecopyresampled($save,$im_sign, $x_pos, $y_pos, 0, 0, $width_src, $height_src, $width_src, $height_src);
        }
//copyright
       if (isset($_REQUEST['copyright_flag']))
       {
          global $copyright_coef;
          $textcolor = imagecolorallocate($save, $colors_value_1[$_REQUEST['copyright_color']],$colors_value_2[$_REQUEST['copyright_color']],$colors_value_3[$_REQUEST['copyright_color']]);
          imageFill($save,0,0,$textcolor); 
          $font = "../images/comic.ttf";
          ImageTTFText($save,imagesx($save)/$copyright_coef[$_REQUEST['copyright_size']],30,25, imagesy($save) ,
              $textcolor,
              $font,
              $_REQUEST['copyright']); 
        }
        //$save_name = str_replace(".JPG",".jpg","{$saveToDir}{$ext[1]}");
        $save_name = str_replace(".JPG",".jpg",$saveToDir);
        $save_name = str_replace(".JPEG",".jpeg",$save_name);
        imagejpeg($save, $save_name);
        imagedestroy($im);
        imagedestroy($save);
/*
        // Crée une image vierge aux bonnes dimensions
        $dst_im = ImageCreateTrueColor($dst_w,$dst_h); 
        // Copie dedans l'image initiale redimensionnée
        $src_im = ImageCreateFromJpeg($img_src);
        // ImageCopyResized($dst_im,$src_im,0,0,0,0,$dst_w,$dst_h,$src_w,$src_h);
        ImageCopyResampled($dst_im,$src_im,0,0,0,0,$dst_w,$dst_h,$src_w,$src_h);
        // Sauve la nouvelle image
        ImageJpeg($dst_im,$img_dest);
        // Détruis les tampons
        ImageDestroy($dst_im);  
        ImageDestroy($src_im);
*/
/*
header("Content-type:image/jpeg"); 
$myImageFile = "photo_01.jpg"; 
$myImage = ImageCreateFromJPEG($myImageFile);
$textcolor = imagecolorallocate($myImage, 255, 0, 0);
// ajout de la phrase en position 0, 200
imagestring($myImage, 5, 0, 200, 
    "P H O T O  n o n  l i b r e  d e  d r o i t s !", 
    $textcolor);
imageJPEG($myImage);
*/
}
//-------------------
function fonction_retire_accents($texte)
{
	/*
  //on coupe si l'on trouve < ou >
	if (strpos($texte,"<"))
	{
		$texte = substr($texte,0,strpos($texte,"<"));
	}
	if (strpos($texte,">"))
	{
		$texte = substr($texte,0,strpos($texte,">"));
	}
	*/
	if (strpos($texte,"&"))
	{
		$texte = ereg_replace("[&]",",",$texte);
	}
	$texte = str_replace("é","e",$texte);
	$texte = str_replace("è","e",$texte);
	$texte = str_replace("ê","e",$texte);
	$texte = str_replace("ë","e",$texte);
	$texte = str_replace("&","_",$texte);
	$texte = str_replace("Î","I",$texte);
	$texte = str_replace("î","i",$texte);
	$texte = str_replace("Ï","I",$texte);
	$texte = str_replace("ï","i",$texte);
	$texte = str_replace("?","_",$texte);
	$texte = str_replace("!","_",$texte);
	$texte = str_replace("@","_",$texte);
	$texte = str_replace("+","_",$texte);
	$texte = str_replace("&","_",$texte);
	$texte = str_replace("ç","c",$texte);
	$texte = str_replace("à","a",$texte);
	$texte = str_replace("ù","u",$texte);
	$texte = str_replace("û","u",$texte);
	$texte = str_replace("ü","u",$texte);
	$texte = str_replace("Ă","a",$texte); 
	$texte = str_replace("'","_",$texte); 
	$texte = str_replace("/","_",$texte); 
	$texte = str_replace("\\","_",$texte); 
	return $texte;
}
?>
