<?php
/*
APPLICATION ATELIERPHP-WEBRAMA - VERSION 3.0	
Application permettant de visualiser des photos sur internet
SITE : WWW.ATELIERPHP.NET			
CONTACT : APPLICATIONS (arobase) ATELIERPHP (point) NET			

Copyright Jean-Marie & Thierry Poulhès Poulhès 2007-2008 Tous droits réservés.

Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
modifier suivant les termes de la “GNU General Public License” (GPL) telle que
publiée par la Free Software Foundation : soit la version 3 de cette
licence, soit (à votre gré) toute version ultérieure.

Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. 
Consultez la Licence Générale Publique GNU pour plus de détails:
<http://www.gnu.org/licenses/gpl-3.0.html> 
ou en français <http://www.april.org/groupes/trad-gpl/doc/GPLv3/www.rodage.org/gpl-3.0.fr.html> 
ou encore <http://fsffrance.org/gpl/gpl-fr.fr.html> 

Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
ce programme (fichier  : licence-gpl-3.0.html); si ce n’est pas le cas, consultez 
les liens ci-dessus.
*/
session_start();
unset ($_SESSION['PassOK']);
isset($_SESSION['display']) ? $display = $_SESSION['display'] : print"" ; 
//ordre de tri des sous-dossiers
isset($_SESSION['sort_flag']) ? $sort_flag = $_SESSION['sort_flag'] : $sort_flag = "SORT_ASC";
if ($sort_flag != "SORT_DESC" and $sort_flag != "SORT_ASC")
{
    $sort_flag = "SORT_DESC";
} 
if ($sort_flag == "SORT_DESC")
{
    $sort_flag = "SORT_ASC";
}
else if ($sort_flag == "SORT_ASC")
{
    $sort_flag = "SORT_DESC";
}
$_SESSION['sort_flag'] = $sort_flag;
//
$fichier = "../photos/titre_principal.txt";
$canal = @fopen($fichier,'r');
if ($canal)
{
	$titre_principal =  fread($canal, filesize ($fichier));
}
else
{
  $titre_principal = "AtelierPHP_Diaporama" ;
	echo "Fichier de titre principal $fichier introuvable <br />";
	echo "<a href=admin/titre_principal.php>Spécifier un titre principal pour l'album</a>";
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<TITLE>Webrama, une application de atelierPHP : visionneuse photo multifonction, <?php echo $titre_principal ?></TITLE>
<LINK rel=stylesheet type="text/css" href="../styles/webrama_style.css">
</HEAD>
<BODY><center>
<p><b><?php echo $titre_principal?></b> <a href="../admin/menu_admin.php" title="Administration générale">
      <img src="../images/cle.png" alt="Administration générale" /></a>&nbsp;&nbsp;&nbsp;
      <a href=../licence.html>Licence : <img src='../images/licence_gplv3.png' alt='texte de licence' title='texte de licence' border=0></a>
      <a href=../lisez_moi.html>Lisez moi!</a>
		</p></center>
<?php
$dossier_photo = "../";
$_SESSION['titre_principal'] = $titre_principal ;
//on ouvre le dossier photos : on va donc lire les noms de dossiers de photos
$allDir = opendir($dossier_photo."photos/");// ouvre le répertoire courrant
unset($entryName);
while($entryName = readdir($allDir))
{   //on enlève les fichiers qui ne sont pas des noms de dossiers 
		if($entryName!="" && $entryName!="." && $entryName!=".." && $entryName!="titre_principal.txt" && $entryName!="index.php" )
    {
			$tableauDossiers[] = $entryName ;
		}
}
if (isset($tableauDossiers) and count($tableauDossiers))
{
    //on trie par nom de dossier mais on va afficher par description, ce qui n'est pas très logique
    //il faut donc avoir des descriptions qui ressemblent au nom de dossier si l'on veut 
    //à l'affichage une liste de description par ordre alphabétique
    sort($tableauDossiers);
    for ($count=0;$count<count($tableauDossiers);$count++)
        {
            $dossier = $tableauDossiers[$count]; 
            $photo_dossier_description = "";
            $mot_de_passe = "";
            $tableau_structure_dossier[$count]["dossier_nom"] = addslashes($tableauDossiers[$count]);
            //c'est encodé en base64 pour ne pas avoir de problème avec les espaces
            $dossier_b64 = base64_encode($tableauDossiers[$count]);
            //si le dossier est protégé : un fichier nommé protected.txt)
            if (file_exists("../photos/$tableauDossiers[$count]/protected.txt")) 
            {
                $fichier = "../photos/$tableauDossiers[$count]/protected.txt";
                $canal = @fopen($fichier,'r');
                $tableau_structure_dossier[$count]["mot_de_passe_dossier"] =  fread($canal, filesize ($fichier));
            }
            else
            {
                $tableau_structure_dossier[$count]["mot_de_passe_dossier"] = "" ;
            }
            //en principe chaque dossier doit contenir un fichier nommé photo_dossier_description
            //alors on lit le titre du dossier et on l'affiche
            $fichier = "../photos/$tableauDossiers[$count]/titre_dossier.txt";
            $canal = @fopen($fichier,'r');
            if ($canal)
            {
            	$tableau_structure_dossier[$count]["dossier_description"] =  addslashes(fread($canal, filesize ($fichier)));
            }
            else
            {
            	$tableau_structure_dossier[$count]["dossier_description"] =  addslashes(utf8_encode($tableauDossiers[$count]));
            }
            //
            //On recherche les sous-dossiers
            //
            $allDir_2 = opendir("../photos/$tableauDossiers[$count]");// ouvre le répertoire courrant
            unset($entryName);
            $pt_sous_dossier=0;
            while($entryName = readdir($allDir_2))
            { 
                  $photo_sous_dossier_description = "";
                  $dossier_b64_loop = base64_encode($entryName);
                  if ($entryName != "." and $entryName != ".." 
                      and $entryName != "photo_dossier_description.txt" and $entryName != "index.php" 
                      and $entryName != "protected.txt" and $entryName != "titre_dossier.txt")
                  {
                            //echo $entryName."*".$pt_sous_dossier."<br />";
                            $tableau_sous_dossier_nom[$dossier][$pt_sous_dossier] =  ($entryName) ;
                            $fichier = "../photos/$tableauDossiers[$count]/$entryName/legendes/generique.txt";
                            $canal = @fopen($fichier,'r');
                            //en principe chaque dossier doit contenir un fichier nommé photo_dossier_description
                            if ($canal)
                            {
                            	$tableau_sous_dossier_description[$dossier][$pt_sous_dossier] =  ucfirst((fread($canal, filesize ($fichier))));
                            }
                            else
                            {
                            	$tableau_sous_dossier_description[$dossier][$pt_sous_dossier] =  ucfirst($tableau_structure_sous_dossier[$dossier][$entryName]["sous_dossier"]);
                            }
                            $fichier_pass = "../photos/$tableauDossiers[$count]/$entryName/protected.txt";
                            $canal = @fopen($fichier_pass,'r');
                            //en principe chaque dossier doit contenir un fichier nommé photo_dossier_description
                            if ($canal)
                            {
                            	$tableau_sous_dossier_protection[$dossier][$pt_sous_dossier] =  ((fread($canal, filesize ($fichier_pass))));
                            }
                            else
                            {
                            	$tableau_sous_dossier_protection[$dossier][$pt_sous_dossier] =  "";
                            }
                            $pt=0;                            
                            //lecture des noms des photos, création du fichier rss
                          	$chemin_photo = "../photos/".$tableau_structure_dossier[$count]["dossier_nom"]."/".$entryName."/";
                          	//echo $chemin_photo.$pt_sous_dossier."<br />";
                            $canal = fopen($chemin_photo.'webrama.rss','w'); //ouverture du fichier en ecriture, création si non existant
                            fwrite($canal, '<?xml version="1.0" encoding="utf-8" standalone="yes"?>
                            <rss xmlns:media="http://search.yahoo.com/mrss" version="2.0"><channel> ');
                            $allDir_3 = opendir("../photos/$tableauDossiers[$count]/$entryName/diapos");// ouvre le répertoire des diapos
                            unset($entryName_3);
                            while($entryName_3 = readdir($allDir_3))
                            {
                          	  if(substr($entryName_3,-5)==".jpeg" or substr($entryName_3,-4)==".jpg" or substr($entryName_3,-5)==".JPEG" or substr($entryName_3,-4)==".JPG")
                          		 {
                          		 $pt++;
                         	  	 $my_photo_vignette_rss = "vignettes/".$entryName_3; //emplacement de la vignette
                         	     $my_photo_vignette_rss =  $my_photo_vignette_rss; //on remplace les espaces par %20 pour la barre d'adresse
                           	   $my_photo_diapo_rss = "diapos/".$entryName_3; 
                           	   $my_photo_diapo_rss =  $my_photo_diapo_rss;
                                  fwrite($canal, "<item><br />
                                          <title>$my_photo_vignette_rss</title>
                                          <link>$my_photo_diapo_rss</link>
                                          <media:thumbnail url=".'"'.$my_photo_vignette_rss.'"'." />
                                          <media:content url=".'"'.$my_photo_diapo_rss.'"'." />
                                          <br /></item><br />"); 
                              }
                            }
                            fwrite($canal, "</channel></rss>");  //piclens
                            fclose($canal);
                            $tableau_nb_photos[$dossier][$pt_sous_dossier]=$pt;
                $pt_sous_dossier++;
                }
              }
            }
            ?>
            <table align=left><tr><td>
            <form action=<?php echo $_SERVER['PHP_SELF'] ; ?> >
            <input type="hidden" name="display_all" value="on">
            <input type="image" src="../images/plus.jpg"  name="ok" title='Afficher tout'></form>
            </td><td><form action=<?php echo $_SERVER['PHP_SELF'] ; ?> >
            <input type="hidden" name="display_off" value="on">
            <input type="image" src="../images/moins.jpg"  name="ok" title='Cacher les sous-dossiers'></form></td></tr></table>
            <?php
            for ($i=0; $i< count($tableau_structure_dossier) ;$i++)
            { 
                $dossier = $tableau_structure_dossier[$i]['dossier_nom']; 
                $dossier_description = stripslashes($tableau_structure_dossier[$i]['dossier_description']); 
                if (isset($tableau_sous_dossier_description[$dossier]))
                {
                echo "<br clear=all><br><font size=+1><b> $dossier_description</b></font><small> (Dossier : $dossier)</small>";
                if (isset($_REQUEST['display_all']) and $_REQUEST['display_all']=="on")
                {
                    $display[$dossier] = "on";
                }
                if (isset($_REQUEST['display_off']) and $_REQUEST['display_off']=="on")
                {
                    $display[$dossier] = "";
                }
                if ($tableau_structure_dossier[$i]["mot_de_passe_dossier"] != "" )
                {
                    $protection_flag=1;                              
                }
                else
                {
                    $protection_flag=0;                              
                }
                ?>
                <?php
                if ($sort_flag == "SORT_DESC")
                {
                  if (isset($_REQUEST['ordre_de_tri'][$dossier]) and $_REQUEST['ordre_de_tri'][$dossier]=="tri_par_description")
                  {
                    array_multisort($tableau_sous_dossier_description[$dossier],SORT_DESC, $tableau_sous_dossier_nom[$dossier],$tableau_sous_dossier_protection[$dossier],$tableau_nb_photos[$dossier]);
                  }
                  else
                  {
                    array_multisort($tableau_sous_dossier_nom[$dossier],SORT_DESC,  $tableau_sous_dossier_description[$dossier],$tableau_sous_dossier_protection[$dossier],$tableau_nb_photos[$dossier]);
                  }
                }
                else
                {
                  if (isset($_REQUEST['ordre_de_tri'][$dossier]) and $_REQUEST['ordre_de_tri'][$dossier]=="tri_par_description")
                  {
                    array_multisort($tableau_sous_dossier_description[$dossier],SORT_ASC, $tableau_sous_dossier_nom[$dossier],$tableau_sous_dossier_protection[$dossier],$tableau_nb_photos[$dossier]);
                  }
                  else
                  {
                    array_multisort($tableau_sous_dossier_nom[$dossier], SORT_ASC,  $tableau_sous_dossier_description[$dossier],$tableau_sous_dossier_protection[$dossier],$tableau_nb_photos[$dossier]);
                  }
                }
                  $nb_lines = count($tableau_sous_dossier_nom[$dossier]);
                  //on regarde si l'on a cliqué sur un plus ou un moins
                  if (isset($_REQUEST['display'][$dossier]))
                  {
                    $display[$dossier] = $_REQUEST['display'][$dossier] ; 
                  }
                  if (isset($display[$dossier]) and $display[$dossier]=="on")
                  {
                    ?>
                  <div style = margin-left:20px;></center><table border="1" align="left" cellpadding="2" width=70%>
                  <tr><th>&nbsp;</th><th><small>Protégé</small></th>
                  <th>
                    <form action=<?php echo $_SERVER['PHP_SELF'] ; ?> >
                    <input type="hidden" name="ordre_de_tri[<?php echo $dossier ?>]" value="tri_par_nom">
                    <!--<input type="hidden" name="display[<?php echo $dossier ?>]" value="<?php echo $_REQUEST['display'][$dossier]?>">-->
                    <input type='submit' value='Trier par nom de dossier'></form>
                  </th>
                  <th>
                    <form action=<?php echo $_SERVER['PHP_SELF'] ; ?> >
                    <input type="hidden" name="ordre_de_tri[<?php echo $dossier ?>]" value="tri_par_description">
                    <!--<input type="hidden" name="display[<?php echo $dossier ?>]" value="<?php echo $_REQUEST['display'][$dossier]?>">-->
                    <input type='submit' value='Trier par description'></form>
                  </th>
                  <th><small>#photos</small></th></tr>
                    <tr><th rowspan=<?php echo $nb_lines?>>
                    <form action=<?php echo $_SERVER['PHP_SELF'] ; ?> >
                    <input type="hidden" name="ordre_de_tri[<?php echo $dossier ?>]" value="<?php echo $_REQUEST[ordre_de_tri][$dossier]?>">
                    <input type="hidden" name="display[<?php echo $dossier ?>]" value=off>
                    <input type='submit' style="font-size:14pt" ; value='--'></form>
                    </th>
                    <?php
                    for ($j=0; $j< count($tableau_sous_dossier_nom[$dossier]) ;$j++)
                    { 
                      $sous_dossier = $tableau_sous_dossier_nom[$dossier][$j];
                      $sous_dossier_description = $tableau_sous_dossier_description[$dossier][$j];
                      $sous_dossier_protection = $tableau_sous_dossier_protection[$dossier][$j];
                      if ($protection_flag ==1 or $sous_dossier_protection)
                      {
                           echo "<td><img src=../images/cle.png hight=15 width=15></td>";
                      }
                      else
                      {
                          echo "<td>&nbsp;</td>";
                      }                  
                      ?>
                      <td align=left width=30%><a href="../programmes/voir_diapos.php?dossier=<?php echo $dossier?>&sous_dossier=<?php echo $sous_dossier ?>"><?php echo $sous_dossier ?></a></td>
                      <td align=left width=60%><a href="../programmes/voir_diapos.php?dossier=<?php echo $dossier?>&sous_dossier=<?php echo $sous_dossier ?>"><?php echo $sous_dossier_description ?></a></td>
                      <td align=left>&nbsp;
                      <small><?php echo $tableau_nb_photos[$dossier][$j] ?> </small></td></tr>
                    <?php
                    }
                  }
                  else
                  {
                    ?>
                  <div style = margin-left:20px;> </center><table border="1" align="left" cellpadding="2" width=70%>
                    <tr><th colspan=5 align=left>
                    <form action=<?php echo $_SERVER['PHP_SELF'] ; ?> >
                    <input type="hidden" name="ordre_de_tri[<?php echo $dossier ?>]" value="<?php echo $_REQUEST[ordre_de_tri][$dossier]?>">
                    <input type="hidden" name="display[<?php echo $dossier ?>]" value=on>
                    <input type='submit' style="font-size:14pt" ; value='+'><i><small>Cliquer sur le "+" pour voir les rubriques</small></i></form>
                    </th></tr>
                    <?php
                  }
              (isset($display))? $_SESSION['display'] = $display : print "";
              }                 
               echo "</table></div>";
            }
}
else
{
    echo "<font color=red>Il n'y a aucune catégorie à visualiser <br /></font>";
    echo "<a href=../admin/menu_admin.php>Administration générale : créer une catégorie </a><br />";
}
echo "<br clear=all>";
$dossier="../";
include("../pied_de_page/pied_de_page.php");
?>
</body>
</html>
