<?php
/*
APPLICATION ATELIERPHP-WEBRAMA - VERSION 3.0	
Application permettant de visualiser des photos sur internet
SITE : WWW.ATELIERPHP.NET			
CONTACT : APPLICATIONS (arobase) ATELIERPHP (point) NET			

Copyright Jean-Marie & Thierry Poulhès Poulhès 2007-2008 Tous droits réservés.

Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
modifier suivant les termes de la “GNU General Public License” (GPL) telle que
publiée par la Free Software Foundation : soit la version 3 de cette
licence, soit (à votre gré) toute version ultérieure.

Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. 
Consultez la Licence Générale Publique GNU pour plus de détails:
<http://www.gnu.org/licenses/gpl-3.0.html> 
ou en français <http://www.april.org/groupes/trad-gpl/doc/GPLv3/www.rodage.org/gpl-3.0.fr.html> 
ou encore <http://fsffrance.org/gpl/gpl-fr.fr.html> 

Vous devriez avoir reçu une copie de la Licence Générale Publique GNU avec
ce programme (fichier  : licence-gpl-3.0.html); si ce n’est pas le cas, consultez 
les liens ci-dessus.
*/
require ("../variables/variables.php");
if (isset($_REQUEST['adminPass']) and isset($adminPass) and trim($_REQUEST['adminPass'])== $adminPass) 
{
    $_SESSION['adminPassOK'] = $adminPass;
}
if (!isSet($_SESSION['adminPassOK']) )
{
  ?>
  <HTML>
  <HEAD>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <TITLE>Webrama, une application de atelierPHP : visionneuse photo mode vignettes </TITLE>
  <LINK rel=stylesheet type="text/css" href="../styles/webrama_style.css">
  </head>
  <body  ONLOAD='document.pass.adminPass.focus()'
  <?php
  echo "<h4>Un mot de passe est necessaire pour accéder au menu d'administration</h4>";
	echo "<FORM name='pass' ACTION=$_SERVER[PHP_SELF] METHOD='POST'>
	<TABLE BORDER='0' CELLSPACING='0' CELLPADDING='0' STYLE='font-family: sans-serif; font: 8pt' width=100%>
	<tr><td align=right><input type=password NAME=adminPass value = '' size='12' maxlength='20'></td>
	<TD ALIGN='left' HEIGHT='35' VALIGN='middle'><INPUT TYPE='submit' VALUE='Envoyer le mot de passe' STYLE='background: transparent; color: darkgreen'></td></tr>
	</TABLE></FORM>";
}
else
{
  $dossier_base = "../";
  $adminPass = $_SESSION['adminPassOK'] ;
  session_destroy();
  require ("../variables/variables.php");
  $_SESSION['adminPassOK'] = $adminPass;
  //on ouvre le dossier photos : on va donc lire les noms de dossiers de photos
  $fichier = "../photos/titre_principal.txt";
  $canal = @fopen($fichier,'r');
  ?>
  <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">
  <html>
  <head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <TITLE>Webrama, une application de atelierPHP : visionneuse photo multifonction, <?php echo $titre_principal ?></TITLE>
  <LINK rel="stylesheet" type="text/css" href="../styles/webrama_style.css">
  <link rel="stylesheet" type="text/css" href="../styles/webrama_style_admin.css">
  </HEAD>
  <BODY><center>
  <h3><p>Webrama, menu d'administration &nbsp; 
        <a href=../licence.html>Licence : <img src='../images/licence_gplv3.png' alt='texte de licence' border=0></a>
              <a href=../lisez_moi.html>Lisez moi!</a>
  		</h3></center>
  <a href=../index.php><img src=../images/accueil.png alt=accueil /></a>
  <?php
  if ($canal)
  {
  	$titre_principal =  fread($canal, filesize ($fichier));
  }
  else
  {
    $titre_principal = "AtelierPHP_Diaporama" ;
  	echo "Fichier de titre principal $fichier introuvable <br />";
  	echo "<a href=admin/titre_principal.php>Spécifier un titre principal pour l'album</a>";
  }
  $_SESSION['titre_principal'] = $titre_principal ;
  $allDir = opendir($dossier_base."photos/");// ouvre le répertoire courrant
  unset($entryName);
  while($entryName = readdir($allDir))
  {   //on enlève les fichiers qui ne sont pas des noms de dossiers 
  		if($entryName!="" && $entryName!="." && $entryName!=".." && $entryName!="titre_principal.txt" && $entryName!="index.php" )
      {
  			$tableauDossiers[] = $entryName ;
  		}
  }
  echo "<span class=album> Album :  $titre_principal </span>
  (<a class=action href=modif_titre_album.php>Modifier le titre de l'album</a>&nbsp;&nbsp; <a class=action href=ajout_dossier.php>Créer un nouveau dossier</a>)<p></p>" ;
  echo "<table border=1 width=100% cellpadding=4>
  <tr class=en_tete_style><th>Item </th><th>Nom</b></th><th>Titre/description</th><th>Mot de passe</th></tr>";
  if (isset($tableauDossiers) and count($tableauDossiers))
  {
      //on trie par nom de dossier mais on va afficher par description, ce qui n'est pas très logique
      //il faut donc avoir des descriptions qui ressemblent au nom de dossier si l'on veut 
      //à l'affichage une liste de description par ordre alphabétique
      asort($tableauDossiers);
      for ($count=0;$count<count($tableauDossiers);$count++)
          {
              $photo_dossier_description = "";
              $mot_de_passe = "";
              $tableau_dossiers["dossier"] = addslashes($tableauDossiers[$count]);
              //c'est encodé en base64 pour ne pas avoir de problème avec les espaces
              $dossier_b64 = base64_encode($tableauDossiers[$count]);
              //si le dossier est protégé : un fichier nommé protected.txt)
              if (file_exists("../photos/$tableauDossiers[$count]/protected.txt")) 
              {
                  $fichier = "../photos/$tableauDossiers[$count]/protected.txt";
                  $canal = @fopen($fichier,'r');
                  $tableau_dossiers["mot_de_passe_dossier"] =  fread($canal, filesize ($fichier));
              }
              else
              {
                  $tableau_dossiers["mot_de_passe_dossier"] = "" ;
              }
              //en principe chaque dossier doit contenir un fichier nommé photo_dossier_description
              //alors on lit le titre du dossier et on l'affiche
              $fichier = "../photos/$tableauDossiers[$count]/titre_dossier.txt";
              $canal = @fopen($fichier,'r');
              if ($canal)
              {
              	$tableau_dossiers["dossier_description"] =  addslashes(fread($canal, filesize ($fichier)));
              }
              else
              {
              	$tableau_dossiers["dossier_description"] =  addslashes(utf8_encode($tableauDossiers[$count]));
              }
              echo "<tr class=dossier_style_1><td><div class=dossier_style_1>&nbsp;&nbsp;Dossier : </div></td><td><div class=dossier_style_1>".
                  $tableau_dossiers['dossier'].
                  "</td><td><div class=dossier_style_1>".stripslashes($tableau_dossiers['dossier_description'])."</div>".
                  "<a class=action href=modif_dossier.php?dossier=$tableau_dossiers[dossier]>Modifier le nom ou la description du dossier</a>&nbsp;&nbsp;&nbsp;
                  <a class=action href=ajout_sous_dossier.php?dossier=$tableau_dossiers[dossier]>Ajouter un sous-dossier</a>
                  </td><td><div class=mot_de_passe>".$tableau_dossiers["mot_de_passe_dossier"]."</td></tr>";
              //
              //On recherche les sous-dossiers
              //
              $allDir_2 = opendir("../photos/$tableauDossiers[$count]");// ouvre le répertoire courrant
              unset($entryName);
              while($entryName = readdir($allDir_2))
              { 
                    $photo_sous_dossier_description = "";
                    $dossier_b64_loop = base64_encode($entryName);
                    if ($entryName != "." and $entryName != ".." 
                        and $entryName != "photo_dossier_description.txt" and $entryName != "index.php" 
                        and $entryName != "protected.txt" and $entryName != "titre_dossier.txt")
                    {
                              $tableau_dossiers["sous_dossier"] =  $entryName ;
                              echo "<tr class=sous_dossier_style_2><td><div class=sous_dossier>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Sous-dossier</div></td><td><div class=sous_dossier>".$entryName."</div></td>" ;
                              $fichier = "../photos/$tableauDossiers[$count]/$entryName/legendes/generique.txt";
                              $canal = @fopen($fichier,'r');
                              //en principe chaque dossier doit contenir un fichier nommé photo_dossier_description
                              if ($canal)
                              {
                              	$tableau_dossiers["sous_dossier_description"] =  ((fread($canal, filesize ($fichier))));
                                echo "<td align=left><a href='../programmes/voir_diapos.php?dossier=$tableau_dossiers[dossier]&sous_dossier=$tableau_dossiers[sous_dossier]'><font size=+1>".stripslashes($tableau_dossiers['sous_dossier_description'])."</font></a>";
                              }
                              else
                              {
                              	$tableau_dossiers["sous_dossier_description"] =  $tableau_dossiers["sous_dossier"];
                                echo "<td align=left>&nbsp;";
                              }
                                                          $pt=0;                            
                              //lecture des noms des photos, création du fichier rss
                              $allDir_3 = opendir("../photos/$tableauDossiers[$count]/$entryName/diapos");// ouvre le répertoire des diapos
                              unset($entryName_3);
                              while($entryName_3 = readdir($allDir_3))
                              {
                            	  if(substr($entryName_3,-5)==".jpeg" or substr($entryName_3,-4)==".jpg" or substr($entryName_3,-5)==".JPEG" or substr($entryName_3,-4)==".JPG")
                            		 {
                            		 $pt++;
                                }
                              }
                              echo " <small>($pt photos) </small>";
                              ?>
                              <br /><a class=action href="modif_sous_dossier.php?dossier=<?php echo $tableau_dossiers['dossier']?>&sous_dossier=<?php echo $tableau_dossiers['sous_dossier']?>">Modifier le nom ou la description du sous_dossier</a>&nbsp;&nbsp;&nbsp; 
                                    <a class=action href="ajout_photos.php?dossier=<?php echo $tableau_dossiers['dossier']?>&sous_dossier=<?php echo $tableau_dossiers['sous_dossier']?>">Ajouter des photos dans ce sous_dossier</a>&nbsp;&nbsp;&nbsp;
                                    <a class=action href="legendes.php?dossier=<?php echo $tableau_dossiers['dossier']?>&sous_dossier=<?php echo $tableau_dossiers['sous_dossier']?>">Gérer les légendes des photos de ce dossier</a>&nbsp;&nbsp;&nbsp; </td>
                              <?php
                              if ($tableau_dossiers['mot_de_passe_dossier'])
                              {
                              echo "<td><div class=mot_de_passe>$tableau_dossiers[mot_de_passe_dossier]</div></td></tr>";
                              }
                              else
                              {
                                //lecture des noms des photos, création du fichier rss
                              	$fichier = "../photos/$tableau_dossiers[dossier]/$tableau_dossiers[sous_dossier]/protected.txt";
                                $canal_pass_sd = @fopen($fichier,'r'); //ouverture du fichier en ecriture, création si non existant
                                if ($canal_pass_sd)
                                {
                                	$tableau_sous_dossiers["mot_de_passe"] =  (fread($canal_pass_sd, filesize ($fichier)));
                                  echo "<td><div class=mot_de_passe>$tableau_sous_dossiers[mot_de_passe]</div></td></tr>";
                                }
                                else
                                {
                                	$tableau_sous_dossiers["mot_de_passe"] =  "";
                                  echo "<td>&nbsp;</div></td></tr>";
                                }
                              }
                  }
              }
            echo "</td></tr>";
      }
        echo "<tr class=dossier_style_1><td colspan=5></td></tr></table></td></tr>";
  }
  else
  {
      echo "<font color=red>Il n'y a aucune catégorie à visualiser <br /></font>";
      $dossier = "../";
      include("../pied_de_page/pied_de_page.php");
      exit ();
  }
}
echo "<a href=../index.php><img src=../images/accueil.png alt=accueil /></a><br />";
$dossier = "../";
include("../pied_de_page/pied_de_page.php");
?>
</body>
</html>
